"use strict";

var _compile = _interopRequireDefault(require("../../test/utils/compile"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Object.values', () => {
  it('should replace Object.values with a polyfill', () => {
    const result = (0, _compile.default)(`
      const c = Object.values({ a: 1, b: 2 })
    `);
    expect(result).toMatchSnapshot();
  });
  it('should not import polyfill more than once', () => {
    const result = (0, _compile.default)(`
      const e = Object.values({ a: 1, b: 2 })
      const f = Object.values({ a: 1, b: 2 })
    `);
    expect(result).toMatchSnapshot();
  });
  it('should work when part of a call chain', () => {
    const result = (0, _compile.default)(`
      const c = Object.keys(Object.values({ a: 1, b: 2 }))
    `);
    expect(result).toMatchSnapshot();
  });
  it('should work when using apply', () => {
    const result = (0, _compile.default)(`
      const c = Object.values.apply(null, [{ a: 1, b: 2 }])
    `);
    expect(result).toMatchSnapshot();
  });
  it('should work when using call', () => {
    const result = (0, _compile.default)(`
      const c = Object.values.call(null, { a: 1, b: 2 })
    `);
    expect(result).toMatchSnapshot();
  });
});