"use strict";

var _compile = _interopRequireDefault(require("../../test/utils/compile"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Promise.all', () => {
  it('should replace Promise.all with a polyfill', () => {
    const result = (0, _compile.default)(`
      const c = Promise.all([])
    `);
    expect(result).toMatchSnapshot();
  });
  it('should not import polyfill more than once', () => {
    const result = (0, _compile.default)(`
      const e = Promise.all([Promise.all([1, 2])])
    `);
    expect(result).toMatchSnapshot();
  });
  it('should work when part of a call chain', () => {
    const result = (0, _compile.default)(`
      const c = Object.keys(Promise.all([]))
    `);
    expect(result).toMatchSnapshot();
  });
});