"use strict";

var _compile = _interopRequireDefault(require("../../test/utils/compile"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('String.prototype.startsWith', () => {
  it('should replace String.prototype.startsWith with a polyfill', () => {
    const result = (0, _compile.default)(`
      const text = 'this is a string'
      if (text.startsWith('a') === true) {
        console.log('success')
      } else {
        console.log('failure')
      }
    `);
    expect(result).toMatchSnapshot();
  });
  it('should not import polyfill more than once', () => {
    const result = (0, _compile.default)(`
      const text = 'this is a string'
      if (text.startsWith('a')) {
        console.log(text.startsWith('a'))
      } else {
        console.log('failure')
      }
    `);
    expect(result).toMatchSnapshot();
  });
  it('should work when part of a call chain', () => {
    const result = (0, _compile.default)(`
      const text = 'this is a string'
      if (text.substr(5).startsWith('a')) {
        console.log('success')
      } else {
        console.log('failure')
      }
    `);
    expect(result).toMatchSnapshot();
  });
});