"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createImport;

var _core = require("@babel/core");

function createImport(file, name, path) {
  const imported = file.path.node.body.find(node => _core.types.isImportDeclaration(node) && _core.types.isStringLiteral(node.source) && node.source.value === path);

  if (imported) {
    return imported.specifiers[0].local;
  }

  const identifier = file.scope.generateUidIdentifier(name);
  file.path.node.body.unshift(_core.types.importDeclaration([_core.types.importDefaultSpecifier(identifier)], _core.types.stringLiteral(path)));
  return identifier;
}