"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createPrototypeMethodTransform;

var _package = require("../../package.json");

var _createImport = _interopRequireDefault(require("./createImport"));

var _isPolyfillPath = _interopRequireDefault(require("./isPolyfillPath"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createPrototypeMethodTransform(polyfill) {
  const property = polyfill.split('.').pop();
  return {
    CallExpression(path, {
      file
    }, {
      types: t
    }) {
      const {
        filename
      } = file.opts;

      if ((0, _isPolyfillPath.default)(filename)) {
        return;
      }

      if (!t.isMemberExpression(path.node.callee) || !t.isIdentifier(path.node.callee.property) || path.node.callee.property.name !== property) {
        return;
      }

      const identifier = (0, _createImport.default)(file, polyfill.split('.').join('_'), `${_package.name}/polyfills/${polyfill.split('.').join('/')}`);
      path.replaceWith(t.callExpression(identifier, [path.node.callee.object, ...path.node.arguments]));
    }

  };
}